<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\MAN\Services;

class ProdParams extends  \Teknisa\MAN\Controllers\TeknisaCrud{

    protected $dataSourceAlteraProd     = 'vnd10003_alteraprod';
	protected $parameterBagColumns      = array('NRORG', 'CDFILIAL', 'CDARVPRODINI', 'CDARVPRODFIN', 'CDPRODUTOINI', 'CDPRODUTOFIN');

    protected $ProdFiliService;


	public function __construct ($crudService, $parameterBag, $entityManager, Services\ProdFili $ProdFiliService,Manager $dataSourceManager) {
		$this->crudService 				= $crudService;
		$this->parameterBag 			= $parameterBag;
        $this->entityManager            = $entityManager;
        $this->ProdFiliService          = $ProdFiliService;
        $this->dataSourceNameManager = $dataSourceManager;
	}

    public function saveAlteraProdParams(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = $this->dataSourceAlteraProd;
        $request->getDataSet()->setDataSourceName($this->dataSourceName);
        
        $row            = $request->getDataSet()->getRows()[0];
        $PRODUTOS       = $row['PRODUTOS'];
        $CDNVPRODUTO    = $row['CDNVPRODUTO'];
        $NRORG          = $row['NRORG'];
        $row['__is_new']= false;
        if($PRODUTOS == "" || !(isset($PRODUTOS))){
            $CDARVPRODINI   = $row['CDARVPRODINI'];
            $CDARVPRODFIN   = $row['CDARVPRODFIN'];
            $products = $this->ProdFiliService->getProdList($CDARVPRODFIN, $CDARVPRODINI, $CDNVPRODUTO, $NRORG);
        }else{
            $PRODUTOS = $this->buildParamValue($row["PRODUTOS"]);
            $products = $this->ProdFiliService->getProdDetails($PRODUTOS, $CDNVPRODUTO, $NRORG);
        }
        foreach ($products as $product) {
            $row['CDPRODUTO'] = $product['CDPRODUTO'];
            $row['CDARVPROD'] = $product['CDARVPROD'];
            if($row['IDPESAPROD'] == null){
                $row['IDPESAPROD'] = $product['IDPESAPROD'];
            }
            if($row['QTTARAPROD'] == null){
                $row['QTTARAPROD'] = $product['QTTARAPROD'];
            }
            if($row['IDCOBTXSERV'] == null){
                $row['IDCOBTXSERV'] = $product['IDCOBTXSERV'];
            }
            if($row['IDTIPOPROD'] == null){
                $row['IDTIPOPROD'] = $product['IDTIPOPROD'];
            }
            if($row['IDIMPPRODUTO'] == null){
                $row['IDIMPPRODUTO'] = $product['IDIMPPRODUTO'];
            }
            if($row['IDIMPRODUVEZ'] == null){
                $row['IDIMPRODUVEZ'] = $product['IDIMPRODUVEZ'];
            }
            parent::save($request,$response);
        }
    }

    public function exportaProdFili(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10003_prodFili';
        $row = $request->getDataSet()->getRows();
        if (count($row[0]) > 7){
            $params = array( 
                'CDFILIORIG' => $row[0]['CDFILIORIG'],
                'CDFILIDEST' => $row[0]['CDFILIDEST'],
                'IDTPFILDEST' => $row[0]['IDTPFILDEST'],
                'IDTPCONFPAR' => $row[0]['IDTPCONFPAR'],
                'CDPRODINIC' => $row[0]['CDPRODINIC'],
                'CDPRODFINA' => $row[0]['CDPRODFINA'],
                'LISTAPARAM' => $row[0]['LISTAPARAM']
            );
            $this->ReplicaProdFiliProced->ExportaProdFili($params);
        }else{
            $CDFILIAL = $row[0]['CDFILIAL'];
            $NRORG = $row[0]['NRORG'];
            $this->ProdFiliService->refreshProduct($CDFILIAL, $NRORG);
        }
    }
    
    public function buildParamValue ($arr) {
        return array_reduce($arr, function($accumulator, $element) {
            return $accumulator."|".$element;
        }, "")."|";
    }
}