<?php
namespace Teknisa\MAN\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class ProdutoRepository {

    protected  $entityManager;
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */
    public function getMaxId($cdprodnivante, $nrorg) {
        $query = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_MAXCDARVPROD);
        $query->execute(array('CDPRODNIVANTE' => $cdprodnivante,
                              'NRORG' => $nrorg));
        return $query->fetchAll();
    }

    public function getProdutoPai($cdprodnivante, $nrorg) {
        $query = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_DISTINCT_CDARVPROD);
        $query->execute(array('CDPRODNIVANTE' => $cdprodnivante,
                              'NRORG' => $nrorg));
        return $query->fetchAll();
    }

    public function checaFilhos($nrorg, $cdproduto){
        $query = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_CDPRODUTO_WHERE_NOT_EXISTS);
        $query->execute(array('CDPRODUTO' => $cdproduto,
                             'NRORG'     => $nrorg));
        return $query->fetchAll();
    }


    public function validaCodigo($cdarvprod, $nrorg) {
        $stmt = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_CDARVPROD_BY_NRORG);
        $stmt->execute(array('CDARVPROD' => $cdarvprod,
                             'NRORG'     => $nrorg));
        $idRow = $stmt->fetchAll();
        foreach ($idRow as $row) {
            if($row['CDARVPROD'] == $cdarvprod) {
                return true;
            }
        }
        return false;
    }

    public function validaCodigoBarras($cdbarproduto) {
        $stmt = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_CDBARPRODUTO);
        $stmt->execute(array('CDBARPRODUTO' => $cdbarproduto));
        $idRow = $stmt->fetchAll();
        foreach ($idRow as $row) {
            if($row['CDBARPRODUTO'] == $cdbarproduto) {
                return true;
            }
        }
        return false;
    }

    public function getCdpictprod($params) {
        $nrorg = $params['NRORG'];
        $stmt = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_CDPICTPROD);
        $stmt->execute(array('NRORG' => $nrorg));
        return $stmt->fetchAll();
    }

    public function getUltNvProd($params) {
        $nrorg = $params['NRORG'];
        $stmt = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_MAXCDNVPRODUTO);
        $stmt->execute(array('NRORG' => $nrorg));
        return $stmt->fetchAll();
    }


} 