<?php
namespace Teknisa\MAN\Services;

use Doctrine\DBAL\Connection;
use Teknisa\MAN\Utilities;

class ObjetivoVenda{
    
    protected $conn;

    public function __construct(Connection $conn) {
        $this->conn = $conn;
    }
    
    public function exportObjetivoWithoutOverwrite($CDFILIAL,$CDOBJMES,$CDOBJANO,$VROBJREALMES,$VROBJDESAFIOMES,$VRTICKETMES,$NRORG,$CDOPERADOR,$CDFILIAL_ORIGEM,$CDOBJMES_ORIGEM,$CDOBJANO_ORIGEM){
        $params = array(
            ':CDFILIAL'         =>  $CDFILIAL,
            ':CDOBJMES'         =>  $CDOBJMES,
            ':CDOBJANO'         =>  $CDOBJANO,
            ':VROBJREALMES'     =>  $VROBJREALMES,
            ':VROBJDESAFIOMES'  =>  $VROBJDESAFIOMES,
            ':VRTICKETMES'      =>  $VRTICKETMES,
            ':NRORG'            =>  $NRORG,
            ':CDOPERADOR'       =>  $CDOPERADOR,
            ':CDFILIAL_ORIGEM'  =>  $CDFILIAL_ORIGEM,
            ':CDOBJMES_ORIGEM'  =>  $CDOBJMES_ORIGEM,
            ':CDOBJANO_ORIGEM'  =>  $CDOBJANO_ORIGEM
        );
        
        $result = $this->conn->executeQuery(Utilities\Query::EXPORT_OBJETIVO_WITHOUT_OVERWRITE,$params);
 
    }
     public function exportObjetivoDiaWithoutOverwrite($CDFILIAL,$CDOBJMES,$CDOBJANO,$NRDIASEMANA,$CDFILIAL_ORIGEM,$NRORG,$CDOBJANO_ORIGEM,$CDOBJMES_ORIGEM){
        $params = array(
            ':CDFILIAL'         =>  $CDFILIAL,
            ':CDOBJMES'         =>  $CDOBJMES,
            ':CDOBJANO'         =>  $CDOBJANO,
            ':NRDIASEMANA'      =>  $NRDIASEMANA,
            ':CDFILIAL_ORIGEM'  =>  $CDFILIAL_ORIGEM,
            ':NRORG'            =>  $NRORG,
            ':CDOBJANO_ORIGEM'  =>  $CDOBJANO_ORIGEM,
            ':CDOBJMES_ORIGEM'  =>  $CDOBJMES_ORIGEM
        );
        
        $result = $this->conn->executeQuery(Utilities\Query::EXPORT_OBJETIVODIA_WITHOUT_OVERWRITE,$params);
         
     }
     
     public function exportObjetivoOverwrite($CDFILIAL,$CDOBJMES,$CDOBJANO,$VROBJREALMES,$VROBJDESAFIOMES,$VRTICKETMES,$NRORG,$CDOPERADOR,$CDFILIAL_ORIGEM,$CDOBJMES_ORIGEM,$CDOBJANO_ORIGEM){
        $params = array(
            ':CDFILIAL'         =>  $CDFILIAL,
            ':CDOBJMES'         =>  $CDOBJMES,
            ':CDOBJANO'         =>  $CDOBJANO,
            ':VROBJREALMES'     =>  $VROBJREALMES,
            ':VROBJDESAFIOMES'  =>  $VROBJDESAFIOMES,
            ':VRTICKETMES'      =>  $VRTICKETMES,
            ':NRORG'            =>  $NRORG,
            ':CDOPERADOR'       =>  $CDOPERADOR,
            ':CDFILIAL_ORIGEM'  =>  $CDFILIAL_ORIGEM,
            ':CDOBJMES_ORIGEM'  =>  $CDOBJMES_ORIGEM,
            ':CDOBJANO_ORIGEM'  =>  $CDOBJANO_ORIGEM
        );
        
        $result = $this->conn->executeQuery(Utilities\Query::EXPORT_OVERWRITE_OBJETIVOMES,$params);
 
    }
     public function exportObjetivoDiaOverwrite($CDFILIAL,$CDOBJMES,$CDOBJANO,$NRDIASEMANA,$CDFILIAL_ORIGEM,$NRORG,$CDOBJANO_ORIGEM,$CDOBJMES_ORIGEM){
        $params = array(
            ':CDFILIAL'         =>  $CDFILIAL,
            ':CDOBJMES'         =>  $CDOBJMES,
            ':CDOBJANO'         =>  $CDOBJANO,
            ':NRDIASEMANA'      =>  $NRDIASEMANA,
            ':CDFILIAL_ORIGEM'  =>  $CDFILIAL_ORIGEM,
            ':NRORG'            =>  $NRORG,
            ':CDOBJANO_ORIGEM'  =>  $CDOBJANO_ORIGEM,
            ':CDOBJMES_ORIGEM'  =>  $CDOBJMES_ORIGEM
        );
        $result = $this->conn->executeQuery(Utilities\Query::EXPORT_OVERWRITE_OBJETIVODIA,$params);
         
     }
     
     public function checkRegistroDia ($params){
         $result = $this->conn->fetchAssoc(self::CHECK_REGISTRO_DIA,$params);
         return $result['TOTAL'] == 0;
     }
     
     const CHECK_REGISTRO_DIA = "
        SELECT COUNT(*) AS TOTAL
        FROM OBJVENDADIA
        WHERE CDFILIAL  = :CDFILIAL
        AND CDOBJANO    = :CDOBJANO
        AND CDOBJMES    = :CDOBJMES
        AND NRORG       = :NRORG
        AND NRDIASEMANA = :NRDIASEMANA 
     ";
}